/*  Function for 1:2 Complexation Analysis                  */
/*  A + B <---> AB       K1= [AB]/[A][B]                    */
/*  AB + B <---> BAB     K2= [BAB]/[AB][B]                  */
/*  Delta Abs = e1*[AB] + e2*[BAB}                          */
/*  [A]0 = c[1], [B]T = x[1], Delta Abs = y[i]  (i = 1 - 5) */
/*  K1 = p[1], K2 = p[2],                                   */
/*  e1 = p[3] - p[11], e2 = p[4] - p[12]                    */
   

#include <math.h>
extern double y[],c[];
double mfunction2(double h,double x[],double p[]);

void function(int i,double x[],double p[])
  {
  double max1,min1,mid,fl,fs,fm,a,b,ab,bab;
  int j;
    max1=x[1];min1=0;fl=mfunction2(max1,x,p);fs=mfunction2(min1,x,p);
	if (fl*fs>0) goto fend1;
	for(j=1;j<=100;j++)
      {
       mid=(max1+min1)/2;fm=mfunction2(mid,x,p);
	   if (fm*fs>=0) min1=mid;
       else
          {if (fm*fl>=0) max1=mid; else goto fend1;}
	   if (fabs(fm)<1e-35) break;
	  }
	 b=mid;
	 a=c[1]/(1+p[1]*b*(1+p[2]*b));
	 ab=p[1]*a*b;
	 bab=p[2]*ab*b;
 switch (i) {
   case 1:
	 y[1]=p[3]*ab+p[4]*bab;
	 break;
   case 2:
	 y[2]=p[5]*ab+p[6]*bab;
	 break;
   case 3:
	 y[3]=p[7]*ab+p[8]*bab;
	 break;
   case 4:
	 y[4]=p[9]*ab+p[10]*bab;
	 break;
   case 5:
	 y[5]=p[11]*ab+p[12]*bab;
	 break;
            }   
   return;
fend1:
   printf("\nFail in finding the one root of function2");
  }

double mfunction2(double h,double x[],double p[])
  {
  double a2,f;
  a2=c[1]/(1+p[1]*h+p[1]*p[2]*h*h);
  f=h+p[1]*a2*h+2*p[1]*p[2]*a2*h*h-x[1];
  return (f);
  }