/*  Least Square Parameter Estimation Program    Ver. 3.0     */
/*         Originally Written for DOS by Yasuhisa Kuroda      */
/*         Re-written for DJGPP by Y.K. in 2002               */
#include <stdio.h>
#include <math.h>
#include <dir.h>
#include <stdlib.h>
#include <setjmp.h>
#include <ctype.h>
#include <string.h>
#define MAX_PARA 21
#define MAX_Y 11
#define MAX_X 11

char *me[4];
int xn,ynn,pn,tn,method,no[MAX_Y],cn,wg,wg1,cy2;
double y[MAX_Y],x[MAX_X],p[MAX_PARA],c[11];
jmp_buf jumper; 

double sum(double datay[],double *datax[],double p[],double *a[]);
void jacobian(double *datax[],double p[],double *a[],double *b[],double d);
int gram_schmidt(double *a[],double del[],double r[][MAX_PARA],int iq[]);
double trace(double r[][MAX_PARA]);
void dtstr(double p[],double datay[],double *datax[]);
void error(int rank,int iq[],double r[][MAX_PARA]);
void finalout(char sbnm[],int cy,int rank,int iq[],double ss2,double p[],double r[][MAX_PARA],double datay[],double *datax[],int org);
void function(int i,double x[],double p[]);
void cycleprint(double p1[],double p2[],double ss,int cy,int mess);
int matherr(struct exception *e);


main ()
 {
  char drive[MAXDRIVE],dir[MAXDIR],fname[MAXFILE],ext[MAXEXT];

  char sbnm[50],an[1],*percent;
  int i,j,k,nn,fl,cy,rank,mess,maxl,iq[MAX_PARA];
  int errval; 
  double p1[MAX_PARA],p2[MAX_PARA],r[MAX_PARA][MAX_PARA],sl,sl1,rr,tra,u;
  double del[MAX_PARA],ss1,ss2,damp,d,lamda,slamda,cc1,cc2;
  double *a[MAX_PARA],*datay;
  double *b[MAX_PARA],*datax[MAX_X];

  FILE *inpt;

  me[0]="Linear Least Square";
  me[1]="Damping Gauss-Newton";
  me[2]="Marquardt";
  me[3]="Failed in Memory Acquisition. Quit Program\n";
  percent="%";
  
  y[0]=1.0;maxl=100;
  printf("LEAST SQUARE PARAMETER ESTIMATION.Ver.3.0fm  \n");
  printf("(Originaly Written for DOS and Modified in 2002 \n");
  printf(" by Y. Kuroda, Kyoto Institute of Technology.)\n");
  printf("This program executes parameter optimization for user's functions given\n");
  printf("as y[i]=f(x[j],p[k],c[l]) in function() by using data set n*(y[i],x[j]).\n\n");
  for (i=0; i<=2; i++)
    printf("%d) %s Method\n",i,me[i]);
  printf("Which method do you select ?  ");scanf("%d",&method);
  printf("\n");

/* file read  */
  printf("File Name  :   ");scanf("%s",sbnm);
  fnsplit(sbnm,drive,dir,fname,ext);
  strcat(drive,dir);
  chdir(drive);
  strcat(fname,ext);
  inpt=fopen(fname,"r");
  fscanf(inpt,"%d %d ",&xn,&ynn);
  for (tn=0,i=1;i<=ynn; i++)
    {fscanf(inpt,"%d ",&no[i]);tn+=no[i];}
  printf("Number of Independent Variable x[i]: %d\n",xn);
  printf("Number of Dependent Variable y[i]  : %d\n",ynn);
  for (i=1;i<=ynn;i++)
    printf("Number of Obserbed Point for y[%d] : %d\n",i,no[i]);

/* end of file title read */
  printf("Number of Parameters p[i] ?            ");scanf("%d",&pn);
  printf("Number of Variable Constant c[i] ?     ");scanf("%d",&cn);
  printf("Weight for Data :\n");
  printf(" 1) None  2) 1/y[i]  3) User's Weight  ");scanf("%d",&wg);

  if (method!=2) j=tn+1;
  else
   {
    j=tn+pn+1;
    for (i=0;i<=pn;i++)
      {if ((b[i]=(double *)calloc(tn+1,sizeof(double)))==NULL)
         {printf("%s",me[4]);gets(an);exit(0);}}
   }
  if ((datay=(double *)calloc(tn+1,sizeof(double)))==NULL)
    {printf("%s",me[4]);gets(an);exit(0);}
  for (i=0;i<=xn;i++)
    {if ((datax[i]=(double *)calloc(tn+1,sizeof(double)))==NULL)
	{printf("%s",me[4]);gets(an);exit(0);}}
  for (i=0;i<=pn;i++)
    {if ((a[i]=(double *)calloc(j,sizeof(double)))==NULL)
	{printf("%s",me[4]);gets(an);exit(0);}}
  if (wg==3) wg1=0; else wg1=1;
  
/* data read */
  for (nn=1,i=1;i<=ynn;i++)
    {
     for (j=1;j<=no[i];j++)
       {
        fscanf(inpt,"%lf ",&datay[nn]);
	 for (k=wg1;k<=xn;k++)
	   fscanf(inpt,"%lf ",&datax[k][nn]);
	 nn++;
       }
     }
  fclose(inpt);
/* end of data read */

  if (wg==1)
    for(i=1;i<=tn;i++)
      datax[0][i]=1;
  if (wg==2)
    {for(lamda=1.0,i=1;i<=tn;i++)
	{slamda=fabs(datay[i]);
	 if ((lamda>=slamda)&&(datay[i]!=0)) lamda=slamda;}
     for(i=1;i<=tn;i++)
       {if (datay[i]==0) datax[0][i]=1.0/lamda;
	 else datax[0][i]=fabs(1.0/datay[i]);}}
  if (wg==3)
    {for(i=1;i<=tn;i++)
	datax[0][i]=fabs(1.0/datax[0][i]);}

  errval=setjmp(jumper);
  if (errval!=0)
    {
     printf("\nStart again with different conditions.\n");
     goto out2;
    }

start:
  printf("\n");
  for(i=1;i<=cn;i++)
    {
     printf("Set constsnt : c[%d] = ",i);scanf("%lf",&c[i]);
    }
  if (method!=0)
    {
     printf("\nConvergence Condition :\n");
     printf("  1) Standard (delta s.s < 0.001%s , p[i] < 0.01%s) , 2) User's set.  ",percent,percent);
     scanf("%d",&i);
     if (i==1)
       {cc1=0.00001;cc2=0.0001;}
     else
       {
	 printf("Delta ss (%s) = ",percent);scanf("%lf",&cc1);cc1/=100;
	 printf("Delta p[i] (%s) = ",percent);scanf("%lf",&cc2);cc2/=100;
       }
    }
  if (method==1)
    {
     printf("Set damping factor (Standerd value = 1)  ");
     scanf("%lf",&damp);
    }
  printf("\nStart computation.\nIf you want to break computation, hit 'ctrl'+'c' key.\n");

  if (method==0)
    {
     for (i=1,d=0.5;i<=pn;i++)
       p1[i]=p2[i]=1;
     for (i=1;i<=tn;i++)
	a[0][i]=datay[i];
    }
  else
    {
     printf("Maximum Loop (Standard = 100) : ");scanf("%d",&maxl);printf("\n");
     for (i=1,d=0.000001;i<=pn;i++)
       {printf("Initial p[%d] = ",i); scanf("%lf",&p1[i]); p2[i]=p1[i];}
     ss2=sum(datay,datax,p2,a);
     printf("Initial ss = %lf\n\n",ss2);
     cy=mess=1;fl=cy2=0;
     if (method==2) {lamda=0;goto marquardt;}
    }
  do
    {
     ss1=ss2;
     do
       {
        jacobian(datax,p1,a,b,d);rank=gram_schmidt(a,del,r,iq);
        if (method==0)
	   {for (i=1;i<=rank;i++)
	      p2[iq[i]]=del[iq[i]];
	    goto fprn;}
	 if (fl>0) {printf("\n(Loop %d)\nFail to find smaller ss.\n",cy);cy2=0;}
	 do
	   {
	    for (i=1;i<=rank;i++)
	      r[i][0]=del[i]*damp;
	    for (i=1;i<=rank;i++)
	      p2[iq[i]]=p1[iq[i]]+r[iq[i]][0];
	    ss2=sum(datay,datax,p2,a);
           if (ss1>ss2) goto out1;
	    damp*=0.5;
          }
        while (damp>0.00005);
        fl++;
        if (fl>5)
	   {for (i=1;i<=pn;i++)
	      p2[i]=p1[i];
	    printf("\nPresent computation doesn't give a smaller ss.\n");
	    printf("Stop under Non-convergent Conditions.\nPresent Status ;\n");cy2=0;
	    goto fprn;}
        for (i=1;i<=pn;i++)
          p1[i]=p2[i];
        damp*=2;
       }
     while (ss2>1.00001*ss1);
     mess=2;
out1:
     if (damp<1) damp*=2;
     cycleprint(p1,p2,ss2,cy,mess);mess=1;
     cy++;fl=0;
     if (cy>maxl) 
       {printf("\nPresent computation exceeds loop maximum.\n");
        printf("Stop in Non-convergent Condition.\nPresent Status ;\n");cy2=0;goto fprn;}
     for (j=1,i=1;i<=pn;i++)
       j*=(fabs(r[i][0])<fabs(p2[i])*cc2);
    }
  while (((ss1-ss2)>ss2*cc1)||(j!=1));
  jacobian(datax,p2,a,b,d);
  rank=gram_schmidt(a,del,r,iq);goto fprn;

marquardt:
  do
    {
     ss1=ss2;jacobian(datax,p1,a,b,d);
     for (i=1;i<=tn;i++)
       b[0][i]=a[0][i];
     for (k=1;;)
       {
        for (i=1;i<=pn;i++)
	   for (j=0;j<=pn;j++)
	     a[j][tn+i]=0;
        slamda=sqrt(lamda);
        for (i=1;i<=pn;i++)
          a[i][tn+i]=slamda;
        tn+=pn;
        rank=gram_schmidt(a,del,r,iq);
        tn-=pn;
	 for (i=1;i<=rank;i++)
	   p2[iq[i]]=p1[iq[i]]+del[iq[i]];
	 ss2=sum(datay,datax,p2,a);sl=0;
	 for (i=1;i<=rank;i++)
	   {
	    sl1=0;
	    for (j=1;j<=rank;j++)
	      sl1+=del[iq[j]]*r[iq[i]][iq[j]];
	    sl=sl+sl1*sl1+lamda*del[iq[i]]*del[iq[i]];
	   }
	  sl=-sl;;rr=(ss2-ss1)/sl;
	  if (rr>0.75)
	    {
	     lamda/=2;error(rank,iq,r);tra=trace(r);
	     if (lamda<tra) lamda=0;
	    }
	  else
	    {
	     if (rr<0.25)
	       {
	        u=2-rr;
		 if (u>10) u=10;else if (u<2) u=2;
		 if (lamda<=0)
		   {error(rank,iq,r);tra=trace(r);lamda=tra;u/=2;}
		 lamda*=u;
		 if (lamda>1e6)
		   {
		    printf("\nLamda exceeds limit value (1000000).\n");
		    printf("Present computation don't give a smaller ss.\n");
		    printf("Stop in Non-convergent Condition.\nPresent Status ;\n");cy2=0;
		    goto fprn;
		   }
              }
	    }
        if (ss1>ss2)
	   {
	    if (lamda>10*tra) mess=3;
	    break;
	   }
	 else
	   {
	    if (ss2<1.00001*ss1)
	      {
	       mess=2;
		break;
             }
	   }
	 for (i=1;i<=pn;i++)
	   p2[i]=p1[i];
	 for (i=0;i<=pn;i++)
	   for (j=1;j<=tn;j++)
	     a[i][j]=b[i][j];
       }
     cycleprint(p1,p2,ss2,cy,mess);mess=1;
     cy++;
     if (cy>maxl) 
       {printf("\nPresent computation exceeds loop maximum.\n");
        printf("Stop in Non-convergent Condition.\nPresent Status ;\n");cy2=0;goto fprn;}
     for (j=1,i=1;i<=pn;i++)
       j*=(fabs(del[i])<fabs(p2[i])*cc2);
    }
  while (((ss1-ss2)>ss2*cc1)||(j!=1));
  jacobian(datax,p2,a,b,d);rank=gram_schmidt(a,del,r,iq);
fprn:
  error(rank,iq,r);
  if (cy2!=0) printf("\n\n");
  finalout(sbnm,cy,rank,iq,ss2,p2,r,datay,datax,1);
out2:
  for (i=1;;)
    {
     printf("\nAnother method(1,2) or Output results(3) Graphic data(4) or End(5)  ");
     scanf("%d",&j);printf("\n");
     switch (j)
       {
	 case 0:if (method==2) 
	   for(i=0;i<=pn;i++)
	     free(b[i]);
	   method=0;goto start;
	 case 1:if (method==2) 
	   for(i=0;i<=pn;i++)
	     free(b[i]);
	   method=1;goto start;
	 case 2:
          if (method!=2)
	     {
	      for (i=0;i<=pn;i++)
		 free(a[i]);
	      for (i=0;i<=pn;i++)
		 {if ((a[i]=(double *)calloc(tn+pn+1,sizeof(double)))==NULL)
		    {printf("%s",me[4]);gets(an);exit(0);}}
	      for (i=0;i<=pn;i++)
		 {if ((b[i]=(double *)calloc(tn+1,sizeof(double)))==NULL)
		    {printf("%s",me[4]);gets(an);exit(0);}}
		method=2;
	      }
	    goto start;
	 case 3:
           finalout(sbnm,cy,rank,iq,ss2,p2,r,datay,datax,2);
	    break;
	 case 4:dtstr(p2,datay,datax);break;
	 case 5:goto end;
       }
    }
    
end:   
;
 /*  return 0;  */
 /* ExitToShell();   */
 }   /*   END OF MAIN PROGRAM    */

double sum(double datay[],double *datax[],double p[],double *a[])
 {
  int i,j,k,nn=1;
  double xx[MAX_X],ss=0;
  for (i=1;i<=ynn;i++)
    {
     for (j=1;j<=no[i];nn++,j++)
       {
	 for (k=1;k<=xn;k++)
          xx[k]=datax[k][nn];
	 function(i,xx,p);
	 a[0][nn]=(datay[nn]-y[i])*datax[0][nn];
        ss+=a[0][nn]*a[0][nn];
       }
    }
  return(ss);
 }    /*  END OF SUM  */

void jacobian(double *datax[],double p[],double *a[],double *b[],double d)
 {
  int i,j,k,l,nn;
  double dp,dy,xx[MAX_X];
  for (nn=1,i=1;i<=ynn;i++)
    {
     for (j=1;j<=no[i];nn++,j++)
       {
        for (k=1;k<=xn;k++)
          xx[k]=datax[k][nn];
	 for (l=1;l<=pn;l++)
	   {
	    dp=p[l]*d;
	    p[l]+=dp;
	    function(i,xx,p);
	    dy=y[i];p[l]-=2*dp;
	    function(i,xx,p);
	    a[l][nn]=(dy-y[i])*datax[0][nn]/(2*dp);
	    if (method==2) b[l][nn]=a[l][nn];
	    p[l]+=dp;
	   }
	}
    }
 }    /*  END OF JACOBIAN  */

int gram_schmidt(double *a[],double del[],double r[][MAX_PARA],int iq[])
 {
  int i,j,k,l,rank,idumy;
  double nr[MAX_PARA],nr1[MAX_PARA],z[MAX_PARA],fdumy;
  for (i=1;i<=pn;i++)
    {
     nr[i]=0;iq[i]=i;
     for (j=1;j<=tn;j++)
       nr[i]+=a[i][j]*a[i][j];
    }
  for (i=1;i<=pn;i++)
    {
     if (nr[1]>nr[i]) continue;
     fdumy=nr[1];nr[1]=nr[i];nr[i]=fdumy;
     idumy=iq[1];iq[1]=iq[i];iq[i]=idumy;
    }
  for (i=1;i<=pn;i++)
    for (j=1;j<=pn;j++)
      r[i][j]=0;
  nr1[1]=nr[1];
  for (i=1;i<=pn;i++)
    {
     if (nr1[i]/nr[i]<0.000005) goto gsout;
     r[iq[i]][iq[i]]=sqrt(nr1[i]);
     for (j=1;j<=tn;j++)
       a[iq[i]][j]/=r[iq[i]][iq[i]];
     if (i==pn) continue;
     for (k=i+1;k<=pn;k++)
	{for (l=1;l<=tn;l++)
	   r[iq[i]][iq[k]]+=a[iq[i]][l]*a[iq[k]][l];
	 for (l=1;l<=tn;l++)
	   a[iq[k]][l]-=a[iq[i]][l]*r[iq[i]][iq[k]];}
     for (j=i+1;j<=pn;j++)
	for (nr1[j]=0,k=1;k<=tn;k++)
	  nr1[j]+=a[iq[j]][k]*a[iq[j]][k];
     if (i==pn-1) continue;
     for (j=i+2;j<=pn;j++)
	{if (nr1[i+1]/nr[i+1]>nr1[j]/nr[j]) continue;
	 idumy=iq[i+1];iq[i+1]=iq[j];iq[j]=idumy;
	 nr1[i+1]=nr1[j];
	 fdumy=nr[i+1];nr[i+1]=nr[j];nr[j]=fdumy;}
    }
gsout:rank=i-1;
  for (i=1;i<=pn;i++)
    del[i]=0;
  for (i=1;i<=rank;i++)
    {for (z[iq[i]]=0,j=1;j<=tn;j++)
	z[iq[i]]+=a[iq[i]][j]*a[0][j];
     for (k=1;k<=tn;k++)
	a[0][k]-=a[iq[i]][k]*z[iq[i]];}
  del[iq[rank]]=z[iq[rank]]/r[iq[rank]][iq[rank]];
  if (rank==1) goto gsend;
  for (i=rank-1;i>=1;i--)
    {for (del[iq[i]]=z[iq[i]],j=rank;j>=i+1;j--)
       del[iq[i]]-=r[iq[i]][iq[j]]*del[iq[j]];
     del[iq[i]]/=r[iq[i]][iq[i]];}
gsend:return(rank);
 }      /*   END OF GRAM-SCHUMIDT   */

void error(int rank,int iq[],double r[][MAX_PARA])
 {
  int i,j,k;
  for (i=rank;i>=1;i--)
    {
     r[iq[i]][iq[i]]=1/r[iq[i]][iq[i]];
     j=rank;
     while (((i+1)<=rank)&&(j>=i+1))
       {
	 r[iq[i]][iq[j]]*=r[iq[j]][iq[j]];
	 k=i+1;
	 while ((k<rank)&&(k<=j-1))
	   {
	    r[iq[i]][iq[j]]+=r[iq[i]][iq[k]]*r[iq[k]][iq[j]];
	    k++;
	   }
	 r[iq[i]][iq[j]]=-r[iq[i]][iq[j]]*r[iq[i]][iq[i]];
	 j--;
       }
    }
  for (i=1;i<=rank;i++)
     {
      r[iq[i]][iq[i]]*=r[iq[i]][iq[i]];
      for (j=i+1;j<=rank;j++)
        r[iq[i]][iq[i]]+=r[iq[i]][iq[j]]*r[iq[i]][iq[j]];
     }
 }   /*   END OF ERROR MATRIX   */

double trace(double r[][MAX_PARA])
 {
  int i;double tra;
  for (tra=0,i=1;i<=pn;i++)
    tra+=r[i][i];
  tra=1/tra;
  return(tra);
 }   /*   END OF TRACE    */
 
void cycleprint(double p1[],double p2[],double ss,int cy,int mess)
 {
  int i,j,xpos;
  
  xpos=1+26*cy2;if (cy2==0) j=0; else j=1;
  /* cgotoxy(xpos,25-j*(pn+1),stdout);  */
  printf("Loop %d",cy);
  if (mess==2) printf("(Non smaller ss)");
  if (mess==3) printf("(Too large lamda)");
  printf("\n");
  for (i=1;i<=pn;i++)
    { /* cgotoxy(xpos,25-j*(pn-i+1),stdout);  */
     printf("p[%d] = %-g\n",i,p2[i]);
     p1[i]=p2[i];}
  /* cgotoxy(xpos,25,stdout);  */
  printf("ss = %-g",ss);
  printf("\n\n");
  if (cy2==2) cy2=0; else cy2++;
 }      /*   END OF CYCLE-PRINT   */
 
void finalout(char sbnm[],int cy,int rank,int iq[],double ss2,double p[],double r[][MAX_PARA],double datay[],double *datax[],int org)
 {
  FILE *out;
  char fl[50];
  int i,j,k,nn;
  double xx[MAX_X];
  
  if (org==1)
    out=stdout;
  else
    {
     printf("Output on 1) Console or 2) Disk  ");scanf("%d",&org);
     if (org==1) 
       out=stdout;
     else   
       {printf("File name  :  ");scanf("%s",fl);
        out=fopen(fl,"w");
        printf("\n.......\n");}
    }

  fprintf(out,"* %s * by %s method\n",sbnm,me[method]);
  fprintf(out,"Iteration : %d\n",cy);
  fprintf(out,"      AIC : %-g\n",tn*log(ss2)+2*rank);
  for(i=1;i<=cn;i++)
    fprintf(out," c[%d] = %-g ,",i,c[i]);
  fprintf(out,"\n");
  if (rank==pn)
    fprintf(out,"Full rank parameter.\n");
  else
    {
     fprintf(out,"Found rank deficiency.\n");
     for (i=1;i<=rank;i++)
       fprintf(out,"p[%d] ,",iq[i]);
     fprintf(out,"are normal.\n");
    }
  for (i=1;i<=pn;i++)
    fprintf(out,"Final p[%d] = %-g  s.d. = %-g\n",i,p[i],sqrt(r[i][i]*ss2/(tn-pn)));
  fprintf(out,"Final s.s. = %-g\n\n",ss2);

  if (org==1)
    {printf("1) Print Data Table     2) Next Step  ");scanf("%d",&i);}
  else
     i=1;
     
  if (i==1)
    {fprintf(out,"\nCalculated y[i]  (Observed y[i]");
     for (i=1;i<=xn;i++)
       fprintf(out,"       x[%d]",i);
     fprintf(out,")\n");
     for (nn=1,i=1;i<=ynn;i++)
       {
        for (j=1;j<=no[i];nn++,j++)
	   {
	    for (k=1;k<=xn;k++)
	      xx[k]=datax[k][nn];
	    function(i,xx,p);
	    fprintf(out,"y[%d] = %-12g ( %-12g",i,y[i],datay[nn]);
	    for (k=1;k<=xn;k++)
	      fprintf(out,"  %-10g ",datax[k][nn]);
	    fprintf(out,")\n");
          }
       }
    }  
  if (org==2) fclose(out); 
 }   /*   END OF FINAL OUT   */
 

void dtstr(double p[],double datay[],double *datax[])
 {
  FILE *out;
  char fl[50],yyy[25];
  int i,j,noy[11],ans,ans2,nny,nn,ix,sim;
  double minix,maxx,step,xx[MAX_X],simp[MAX_PARA];
  
  ans2=3;
  printf("Graphic Data Output.\n\n"); 
  do
   {
    printf("Optimized results(1)  Calc.with given parameters(2)  ");scanf("%d",&sim);
    if (sim==2) 
      {
       for(i=1;i<=pn;i++)
         {printf(" p[%d] = ",i);scanf("%lf",&simp[i]);}
       }
    else
      {
       for(i=1;i<=pn;i++)
         simp[i]=p[i];
       }
       
    asky:
    printf("Which y[i] do you select (1,2,3...) ?  ");scanf("%s",yyy);
    nny=sscanf(yyy,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d",&noy[1],&noy[2],&noy[3],&noy[4],&noy[5],&noy[6],&noy[7],&noy[8],&noy[9],&noy[10]);
    for(i=1;i<=nny;i++)
      {if ((noy[i]>ynn)||(noy[i]<=0)) {printf("Obs(%d) is Undefined Obs. !\n",i);goto asky;}}

    printf("Which x[i] Do you Select ?  ");scanf("%d",&ix);      
    askminimaxx:
      printf("Set Minimum and Maximum x[%d]   ",ix);scanf("%lf,%lf",&minix,&maxx);
      if (minix>=maxx) {printf("Illegal Min & Max x[%d] !\n",ix);goto askminimaxx;}
      for(i=1;i<=xn;i++)
        {if (i!=ix)
           {printf("   Value of x[%d] = ",i);scanf("%lf",&xx[i]);}
        }
    askstep:
      printf("Set calculation step size for x[%d]   ",ix);scanf("%lf",&step);
      if (step<=0) {printf("Illegal Step Size !\n");goto askstep;}    
      printf("\n");
      
    printf("\n1) With observed data  2) Calculated data only : ");
/*   fflush(stdin);ans=getchar();        */
    scanf("%d",&ans);
    if (ans2==3)
      {printf("File name  :  ");scanf("%s",fl);
       out=fopen(fl,"w");ans2=4;}
    else
      {printf("On file[%s](1) or Another file(2) ? ",fl);scanf("%d",&ans2);
       if (ans2==2) 
         {fclose(out);
          printf("File name  :  ");scanf("%s",fl);
          out=fopen(fl,"w");}
      }     
  
    printf("\n.......\n");

/*	fprintf(out,"Data for Plot\n");   */
/* Observed Data output    */    
    if (ans==1)
	  {
/*	   fprintf(out,"%d\n",ynn);     */
	   for (nn=1,i=1;i<=ynn;i++)
	   {
/*		fprintf(out,"%d\n",no[i]);    */
		for (j=1;j<=no[i];nn++,j++)
		  {
	          fprintf(out,"%-g ",datax[ix][nn]);
		   fprintf(out,"%-g ",datay[nn]);
		   fprintf(out,"\n");
		  }
  	    fprintf(out,"\n"); 
          }
      } 

/*  Calcd. Data output    */           
	xx[ix]=minix;
/*	fprintf(out,"%d",nny);     */
    while (xx[ix]<maxx)
	  {
	   fprintf(out,"%-g ",xx[ix]);
/*        fprintf(out,"\n%-g ",xx[ix]);      */
          for(i=1;i<=nny;i++)
       	{function(noy[i],xx,simp);fprintf(out,"%-g ",y[noy[i]]);}
          xx[ix]+=step;
          fprintf(out,"\n");
	  }
    fprintf(out,"\n");
    printf("\n1) End of output  2) Other output : ");
/*  fflush(stdin);ans=getchar();       */
    scanf("%d",&ans);
    }
  while(ans==2);

fclose(out);
/* endout: */
  printf("\n\nEnd of File Out.\n");
 }    /*  END OF DATA STORE   */

int matherr(struct exception *e)
 {
  printf("\nMathematical error. Break.\n");
  switch (e->type)
   {case DOMAIN   :printf("Domain error : ");break;
	case SING     :printf("Singularity : ");break;
	case OVERFLOW :printf("Overflow : ");break;
	case UNDERFLOW:printf("Underflow : ");break;
	case TLOSS    :printf("Total loss : ");}
  printf("%s %lf\n",e->name,e->arg1);
  longjmp(jumper,1);
 }
